// MappingLib.h : main header file for the MappingLib DLL
//
#define _USE_MATH_DEFINES
#include <math.h>

#pragma once

// CMappingLibApp
// See MappingLib.cpp for the implementation of this class
//

class CMappingLibApp : public CWinApp
{
public:
	CMappingLibApp();
	void setState( int index );
	void reset( double ini[5], double outi[5] ); // initial state of ins and outs
	BOOL initMapping( double inrs[5][2], double outrs[5][2] );
//	void act( double ins[5], double spd[5], double outs[5], double outspd[5], long& time );
	void act( double ins[5], double outs[5], double time );

private:
	// action method
//	void box1( double ins[5], double spd[5], double outs[5], double outspd[5] ); 
	void box1( double ins[5], double outs[5], double time );
	void box2( double ins[5], double outs[5], double time );
	void box3( double ins[5], double outs[5], double time );
	// initialization method
	void box1( double ini[5], double outi[5] );
	void box2( double ini[5], double outi[5] );
	void box3( double ini[5], double outi[5] );

	double linearmap( double in, int inindex, int outindex ); // helper function for calculating the linear mapping btn in_index and out_index
	int state_index;
	double cur_time;
	double cache[5];
	
	// linear mapping btn ins and outs
	double inr[5][2], outr[5][2]; // 0:st; 1: ed

// Overrides
public:
	virtual BOOL InitInstance();
	DECLARE_MESSAGE_MAP()
	
};
